﻿// ****************************************************************************
// functions.js 
// 
// Revision $Rev: 477 $ 
// Datum:$Date: 2012-07-02 17:09:05 +0200 (Mo, 02 Jul 2012) $
// encoding: utf-8
// touch: xxxx
// ****************************************************************************

// ****************************************************************************
// Globale Settings
// ****************************************************************************
var version       = "2.0";
var debug         = 0;      // u.a. index anzeigen, show_json?
var isIE = (navigator.appName.indexOf("Microsoft")!= -1) ? true : false;
var hide_buttons  = true;  // Blätter-Buttons verstecken?  (sonst nur disablen)
var hideSeekButton = true; // true = kein Suchen-Button rechts von AVV-Key
var pdf_toplink   = false;  // Ursprungs-Version der pdf-Links oben anzeigen (ein pdf pro Datensatz), sonst nur Info-Hinweis
var pflichtFelder = new Array ();  // ('bezeichnung', 'avv_bezeichnung', 'avv_schluessel')
var maxthumbs     = 16;     // max. Anzahl der Thumbnails in Abfrage-Maske


//************************************************************************************
// für leere OECD/Basel-Datensätze (weitere Spezifikationen siehe langspec.BaselOecd
//************************************************************************************
var noAVV6         = '999999';
var noAVV4         = '9999';
var noAVV2         = '99';

//******************************
// Abfallverbringung
//******************************
var showStaatenBlock = false;  // Staatenblock etc. bei Export/Import anzeigen
var showOrganisations = true;  // in Staatenlisten die Mitgliedschaften anzeigen (EU, OECD etc.)?

var Staat = {
   "von"     : "",   // Versandstaat
   "nach"    : "",   // Empfängerstaat  
   "control" : "DE",  // Kontrolle wird durchgeführt in
   
   "von_index"     : 0,
   "nach_index"    : 0,
   "control_index" : 0
};
var BesVerw = ''; // Beseitigung oder Verwertung
//******************************


//*********************************************************************************
// Pfade werden weiter unten noch umgesetzt, siehe "Location spezifische Settings"

var pathimages    = "images";
var paththumbs    = pathimages + "/thumbs";
// alert (parent.ContentFrame.location.href);
if (typeof parent != "undefined"
      && typeof parent.ContentFrame != "undefined" 
      && parent.ContentFrame.location.href.substr(0,24) == "file:///N:/uib/michaelis") {
    pathimages = 'file:///N:/uib/michaelis/Abfall-DB/images';
    paththumbs =  pathimages + '/thumbs';
}
var pathpdf       = "pdf";
var pathpdfCheck  = "pdf";
var download_zip  = "/zip/abfall_offline_client.zip";

var imgDhtmlWrite = 1;      // 0=nur Image jpg anzeigen   1=Image document dynamisch erzeugen

var wichtig_show  = 1;      // Dokumente mit unten stehendem Anzeigenamen rot anzeigen
var wichtig_name  = 'XXX'; // Anzeigename von besonders gekennzeichnetem Zusatzdokument
var wichtig_color = '#054295';
var info_color    = '#054295';

var imgSizeX   = 900; // Bildgröße X
var imgSizeY   = 600; // Bildgröße Y
if (screen.availWidth < 1200 || screen.availHeight < 900) {
   // alert (screen.availWidth +'   '+screen.availHeight);
   imgSizeX   = 600;
   imgSizeY   = 400;   
}
var imgSizeXorg = imgSizeX;
var imgSizeYorg = imgSizeY;
var XYratio = imgSizeXorg / imgSizeYorg;

var imgAddX    = 20;  // + Rand X
var imgAddY    = 100; // + Rand Y (mit Bedien-Elementen)
if (document.all) { // IE
   imgAddX += 10;
   imgAddY += 20;
}

var ffamily         = 'arial,verdana,helvetica,sans-serif';
var class_midtext   = 'font-family:'+ffamily+';font-size:12pt;color:#054295';
var class_smalltext = 'font-family:'+ffamily+';font-size:9pt;color:#054295';


// ****************************************************************************
// do not change:

var imgWinPosX = (screen.availWidth  - (imgSizeX +imgAddX)) / 2;
var imgWinPosY = (screen.availHeight - (imgSizeY +imgAddY)) / 2;
var dragflag   = 0;
var dragStartX = 0;
var dragStartY = 0;

// ****************************************************************************
// Location spezifische Settings
// ****************************************************************************
var hostName = document.location.host;
// alert (hostName);
if (hostName == 'www.hlug.de') {
   debug = 0;   
}

if (langspec.code == 'EN' && (hostName == 'www.hlug.de' || hostName == 'abfalltransportdatenbank.hlug.de')) {
   pathimages   = '../' + pathimages;
   paththumbs   = '../' + paththumbs;
   pathpdf      = '../' + pathpdf;
   pathpdfCheck = pathpdf;
   download_zip = 'http://www.hlug.de/static/medien/abfall/abfall_client/EN/zip/abfall_offline_client.zip';  
}
if (langspec.file.ImgPath) {
   pathimages  = langspec.file.ImgPath;
   paththumbs  = pathimages + '/thumbs';
}
if (langspec.file.PDFpath) {
   pathpdf     = langspec.file.PDFpath;
}
if (langspec.file.PDFpathCheck) {
   pathpdfCheck = langspec.file.PDFpathCheck;
}
if (langspec.file.Download) {
   download_zip = langspec.file.Download;
}
if (langspec.code != 'FR' && (hostName == 'saturn2' || hostName == 'localhost:8017' || document.location.href.search(/test/))!=-1) {
   pathimages   = "../images";
   paththumbs   = "../images/thumbs";
   pathpdf      = "../pdf";
   pathpdfCheck = pathpdf;
   download_zip = "../zip/abfall_offline_client.zip";
}
if (langspec.code != 'FR' && hostName == 'download.uib.de') {
   pathimages   = "../images";
   paththumbs   = "../images/thumbs";
   pathpdf      = "../pdf";
   pathpdfCheck = pathpdf;
   download_zip = "../zip/TransportDesDechetsMaroc.zip";
}

// ****************************************************************************
// Globale Variablen
// ****************************************************************************
var form;       // Eingabe-Formular, Init. in init(), da erst dann Formular vorhanden
var anz_all     = myDB.data.length-1;
var max_index   = anz_all;
var akt_index   = 0;
var anz_gefunden  = 0;
var akt_gefunden  = 0;
var Ergebnis      = new Array (0);
Ergebnis[0] = 0;

var Spiegel      = new Array(); Spiegel[0] = 0;       // AVV-Keys der Spiegel
var SpiegelIndex = new Array(); SpiegelIndex[0] = 0;  // index der Spiegel
var anz_spiegel = Spiegel.length-1;
var initdone    = 0;     // wiederholtes init?

// Abfall-Objekte
var AktScreen   = null;  // aktueller Bildschirminhalt bei Content-Wechsel
var SuchMuster  = null;  // aktuelles Suchmuster

var abfallDBImg = null;  // Image-Window
var pdfWin      = null;  // Anzeigefenster für PDF-Info
var grenzWin    = null;  // Grenztransport-Window
   
// ****************************************************************************
// folgende Struktur wird in myDB.js erwartet:

var checkDB = 
   {
      "data": [
         {
            "anhang_nr": "",
            "avv_bezeichnung": "",
            "avv_schluessel": "",
            "basel_code": "",
            "bezeichnung": "",
            "bilder": [],
            "farbe": "",
            "geruch": "",
            "info_links": [],
            "konsistenz": "",
            "oecd_code": "",
            "spiegeleintrag": "",
            "zusatz": ""
         }
      ],
      
      "attribute": {
         // "farbe":  [],
         // "geruch": [],
         "konsistenz": []
      },
      
      "info": {
         "anzahl": 0,
         "datum": "",
         "version": ""
      },
      
      "indexorder": {
         // "anhang_nr": [],
         // "avv_bezeichnung": [],
         "avv_schluessel": [],
         "basel_code": [],
         // "bezeichnung": [],
         "oecd_code": []
         // "farbe": [],
         // "geruch": [],
         // "konsistenz": [],
         // "spiegeleintrag": [],
         // "zusatz": [],
         // "zoll_code": [],
      },
      
      "avv_katalog": {}
  
   };
   
   var activeFld = 'avv_schluessel';
   setActiveFld(activeFld);
   
// ****************************************************************************
// avv_schluessel in Daten ohne Leerzeichen, in Anzeige mit Leerzeichen
// ****************************************************************************

function strip_blanks (avvkey) {

   var retkey = avvkey;
   retkey = retkey.replace(/ /g, '');
   return retkey; 
}

function add_blanks (avvkey) {

   var retkey = avvkey.substr(0,2) 
          +' '+ avvkey.substr(2,2);

   if (avvkey.length > 4)
      retkey += ' '+ avvkey.substr(4);   // letzter substr evtl. länger (mit Stern)
      
   return retkey; 
}

// ****************************************************************************
// Funktionen (Methoden) und Konstruktor für neues Abfall-Objekt
// ****************************************************************************
// ****************************************************************************
// Inhalt aus übergebenem Objekt in Abfall-Objekt kopieren

function Abfall_copyfrom (ds) {

   for (var feld in checkDB.data[0]) {
      if (ds[feld] == null)
         delete this[feld];
      else
         this[feld] = ds[feld];
   }
}

// ****************************************************************************
// Inhalt vergleichen mit übergebenem Objekt
// return: 0 = gleich
//         1 = alle Suchkriterien erfüllt (d.h. alle Strings von ds sind Teilstrings von this)
//        -1 = Suchkriterien nicht erfüllt (nicht alle Teilstrings vorhanden)

function Abfall_compare (ds) {

   var changed = 0;
   var s1, s2;
   
   for (var feld in checkDB.data[0]) {
      if (feld != 'bilder'  &&  feld != 'spiegeleintrag'  &&  feld != 'info_links') {
         // alert ("key="+ds['avv_schluessel']+"  feld="+feld);
         // Feldinhalt unterschiedlich?
         if (this[feld] != ds[feld]) {
            // alert ("this[feld]="+this[feld]+"  ds[feld]="+ds[feld]);
            changed = 1;
            s1 = this[feld].toUpperCase();  // Suchkriterium
            s2 = ds[feld].toUpperCase();
            
            // in diesem Feld Suchkriterium gesetzt?
            if (s1 != '') { 
               var found = s2.indexOf(s1);  
               // s1 ist kein Substring von s2  ?
               if (found == -1) {
                  changed = -1;
                  // Vergleich beenden wenn Suchkriterien nicht erfüllt
                  break;
               }
            }
         }
      }
   }   
   return changed;
}

// ****************************************************************************
// Inhalt aus Bildschirm in Abfall-Objekt kopieren

function Abfall_readscreen () {

   var isnoAVV = (form['avv_schluessel'].value == langspec.BaselOecd.noAVV);
   
   for (var feld in checkDB.data[0]) {
      if (form[feld] != null) {
         docfeld = form[feld];
         if (docfeld.type == 'text' || docfeld.type == 'textarea') {
            this[feld] = docfeld.value;
         }
         else if (feld == 'spiegeleintrag' && docfeld.type == 'select-one') {
            // Achtung, Anzeige enthält blanks in den AVV-Schluesseln!
            //   this[feld] = docfeld.options[0].text; 
            // vom User nicht änderbar, deshalb aus Original-Daten lesen:
            this[feld] = myDB.data[akt_index].spiegeleintrag;
         }
         else if (docfeld.type == 'select-one') {
            if (myDB.attribute[feld])
               this[feld] = myDB.attribute[feld][docfeld.selectedIndex];
         }
      }
   }
   if (isnoAVV) {   
      // this['avv_schluessel'] = noAVV6;
      // this['avv_schluessel'] = '';
      // this['zusatz']         = '';            
      delete this['avv_schluessel'];         
      delete this['zusatz'];    
   }

   // Leerzeichen aus avv-Schluessel entfernen
   if (this['avv_schluessel'])
      this['avv_schluessel'] = strip_blanks(this['avv_schluessel']);
      
   for (var feld in this)
      if (this[feld] == 'undefined')
         delete this[feld];   
}

// ****************************************************************************
// Inhalt von Abfall-Objekt auf Bildschirm anzeigen - wurde verwendet für Muster-Anzeige.
// Die Haupt-Funktion zur Datenanzeige ist show_data() (s.u.).

function Abfall_writescreen () {

   var isnoAVV = (this['avv_schluessel'] == noAVV6);   
   fill_dropdowns();
   
   for (var feld in this) {
      if (form[feld] != null) {
         if (form[feld].type == 'text' || form[feld].type == 'textarea') {
            if (feld == 'avv_schluessel') {
               if (isnoAVV)
                  form[feld].value = langspec.BaselOecd.noAVV;
               else
                  form[feld].value = add_blanks(this[feld]);
            }
            else
               form[feld].value = this[feld];
         }
         else if (feld == 'spiegeleintrag')
            fill_spiegel (this[feld]);
         else if (form[feld].type == 'select-one') {
            form[feld].selectedIndex = 0;
            if (myDB.attribute[feld]) {
               for (var i=0; i < myDB.attribute[feld].length; i++) {
                  if (myDB.attribute[feld][i] == this[feld]) {
                     form[feld].selectedIndex = i;
                     break;
                  }
               }
            }
         }
      }
   }
   form.avv_bezeichnung.title = form.avv_bezeichnung.value; // avv-bez. als hint   
   form.zusatz.title = '';   
   if (isnoAVV) {
      form['zusatz'] = langspec.BaselOecd.zusatz;      
   }
}


// ****************************************************************************
// Inhalt durchsuchen nach bestimmtem String
// return: 0 = nicht gefunden
//         1 = gefunden im Datensatz
//         2 = gefunden in AVV-Gruppe
//         3 = gefunden in AVV-Kapitel

function Abfall_search (suchstr) {

   var found = 0;
   
   // im Datensatz suchen   
   var s1 = suchstr.toUpperCase();
   for (var feld in checkDB.data[0]) {
      if (feld != 'bilder'  &&  feld != 'spiegeleintrag'  &&  feld != 'info_links') {
         var s2 = this[feld].toUpperCase();
         if (s2.indexOf(s1) > -1)  {
            found = 1;
            break;
         }
      }
   }      
   if (!found && this.avv_bezeichnung == '') { // in AVV-Katalog suchen (falls Feld avv_bezeichnung leer)
      var text = myDB.avv_katalog[this.avv_schluessel].toUpperCase();
      if (text.indexOf(s1) > -1)  
         found = 1;
   }  
   if (!found) { // in AVV-Gruppe suchen
      var gruppe = this.avv_schluessel.substring(0,4);      
      var text = myDB.avv_katalog4_gruppe[gruppe].toUpperCase();
      if (text.indexOf(s1) > -1)  
         found = 2;
   }
   if (!found) { // in AVV-Kapitel suchen
      var kapitel = this.avv_schluessel.substring(0,2);      
      var text = myDB.avv_katalog2_kapitel[kapitel].toUpperCase();
      if (text.indexOf(s1) > -1)  
         found = 3;
   }  
   
   return found;
}


// ****************************************************************************
// Konstruktor für neues Abfall-Objekt

function Abfall (index) {
   
   this.index = index;
   for (var feld in checkDB.data[0]) {
      this[feld] = checkDB.data[0][feld];
   }
   if (index) {   
      for (var feld in myDB.data[index]) 
         this[feld] = myDB.data[index][feld];
   }   
   this.copyfrom    = Abfall_copyfrom;
   this.compare     = Abfall_compare;
   this.readscreen  = Abfall_readscreen;
   this.writescreen = Abfall_writescreen;
   this.search      = Abfall_search;
}
// ****************************************************************************
// ****************************************************************************


// ****************************************************************************
// ****************************************************************************
// Abfall-Datensatz myDB.data[index] auf Bildschirm anzeigen

function show_data (index) {

   var ds = myDB.data[index];
   var kapitel = '';
   var gruppe  = '';
   var kapitel_text = '';
   var gruppe_text  = '';
   var isnoAVV = ds.avv_schluessel == noAVV6;

   fill_dropdowns();
   if (index <= anz_all) {
      // Text-Felder setzen
      for (var feld in checkDB.data[0]) {
         if (form[feld] && (form[feld].type == 'text' || form[feld].type == 'textarea')) {
            if (ds[feld]) {
               if (feld == 'avv_schluessel') {
                  if (ds[feld] == noAVV6)
                     form[feld].value = langspec.BaselOecd.noAVV;
                  else
                     form[feld].value = add_blanks(ds[feld]);
               }
               else
                  form[feld].value = ds[feld];
            }
            else
               form[feld].value = '';
         }
         // Spiegeleintrag
         else if (feld == 'spiegeleintrag')
            fill_spiegel (ds[feld]);
      }      
      // falls avv_bezeichnung leer -> aus avv_katalog holen
      if (akt_index && ds.avv_bezeichnung == '')
         form.avv_bezeichnung.value = myDB.avv_katalog[ds.avv_schluessel];
      // automatische zusatz-info bei noAVV   
      if (isnoAVV) {
         form.zusatz.value = langspec.BaselOecd.zusatz;
         form.zusatz.title = langspec.BaselOecd.tooltip;
      }
      else
         form.zusatz.title = '';

      // Dropdowns setzen
      for (var feld in myDB.attribute) {
         if (form[feld].type == 'select-one') {
            form[feld].selectedIndex = 0;
            for (var i=0; i < myDB.attribute[feld].length; i++) {
               if (myDB.attribute[feld][i] == ds[feld]) {
                  form[feld].selectedIndex = i;
                  break;
               }
            }
         }
      }
      fill_thumbs (index);
      set_infolinks (index);
      set_grenz_verfahren(index);
      form.avv_bezeichnung.title = form.avv_bezeichnung.value; // avv-bez. als hint
      
      if (index) {
         kapitel = ds.avv_schluessel.substring(0,2);
         kapitel_text = myDB.avv_katalog2_kapitel[kapitel];
         if (kapitel == noAVV2)
            kapitel = '';
         
         gruppe  = ds.avv_schluessel.substring(0,4);
         gruppe_text  = myDB.avv_katalog4_gruppe [gruppe];
         if (gruppe == noAVV4)
            gruppe = '';
      }
      parent.ContentFrame.document.getElementById("avv_kapitel").innerHTML = kapitel;
      parent.ContentFrame.document.getElementById("avv_kapitel_text").innerHTML = kapitel_text;
      parent.ContentFrame.document.getElementById("avv_gruppe").innerHTML  = add_blanks(gruppe) + '&nbsp;&nbsp;'; 
      parent.ContentFrame.document.getElementById("avv_gruppe_text").innerHTML  = gruppe_text;       
   }
}


// ****************************************************************************

function open_pdf_win (src) {

      var x = 1000;
      var y = 720;
      
      var imgWinPosX = (screen.availWidth  - x) / 2;
      var imgWinPosY = (screen.availHeight - y) / 2;

      if (pdfWin)
         pdfWin.close();
      
      // Fenster öffnen
      pdfWin = window.open (src, 'pdfWin', 
         'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,dependent=yes,left=0,top=0,location=no'
         + ',width='+x+ ',height=' +y
         + ',left=' + imgWinPosX
         + ',top='  + imgWinPosY
      );
      if (pdfWin)
         pdfWin.focus();
}


// ****************************************************************************
// ****************************************************************************
// Hilfsfunktionen für show_img()

function get_innerWidth (win) {
   
   var defWidth = imgSizeX + imgAddY;
   var Width    = defWidth;
   // all except IE
   if (win.innerWidth)
      Width  = win.innerWidth;
   // IE 6 Strict Mode
   else if (win.document.documentElement && win.document.documentElement.clientWidth) 
      Width = win.document.documentElement.clientWidth;
   // other IE
   else if (win.document.body && win.document.body.clientWidth)
      Width = win.document.body.clientWidth;
   // alert ("innerWidth="+Width);
   if (isNaN(Width))
      Width = defWidth;
   return Width;
}

function get_innerHeight (win) {
   
   var defHeight = imgSizeY + imgAddY;
   var Height    = defHeight;
   // all except IE
   if (win.innerHeight)
      Height  = win.innerHeight;
   // IE 6 Strict Mode
   else if (win.document.documentElement && win.document.documentElement.clientHeight) 
      Height = win.document.documentElement.clientHeight;
   // other IE
   else if (win.document.body && win.document.body.clientHeight)
      Height = win.document.body.clientHeight;
   // alert ("innerHeight="+Height);
   if (isNaN(Height))
      Height = defHeight;
   return Height;
}

function winresize() {

   if (abfallDBImg) {
      imgSizeX = get_innerWidth (abfallDBImg) - imgAddX;
      imgSizeY = get_innerHeight(abfallDBImg) - imgAddY;
      if (imgSizeX/imgSizeY > XYratio)
         imgSizeX = imgSizeY * XYratio;
      else 
         imgSizeY = imgSizeX / XYratio;
      abfallDBImg.document.getElementById("img1").width  = imgSizeX;
      abfallDBImg.document.getElementById("img1").height = imgSizeY;
   }
}

function dragstart(e) {

   if (abfallDBImg) {
      if(!document.all)  // kein IE, kein globales event-Objekt
         {event = e;}
      dragStartX = event.screenX;
      dragStartY = event.screenY;
      if (form.test1) form.test1.value = 'Screen X/Y = '+dragStartX+' '+dragStartY;
      dragflag = 1;
   }
}

function drag(e) {

   if (abfallDBImg && dragflag) {
      if(!document.all)  // kein IE, kein globales event-Objekt
         {event = e;}
      var diffX = event.screenX - dragStartX;
      var diffY = event.screenY - dragStartY;
      // abfallDBImg.moveBy(diffX,diffY);
      if (form.test2) form.test2.value = 'diff X/Y = '+diffX+' '+diffY;
      return true;
   }
   return false;
}

function dragstop(e) {

   if (abfallDBImg) {
      if(!document.all)  // kein IE, kein globales event-Objekt
         {event = e;}
   }
   dragflag = 0;
}


// ****************************************************************************
// ****************************************************************************
// Bilder anzeigen

function show_img (name, index, img_index) {

   var imgsrc  = pathimages+'/'+name;
   var loadsrc = imgsrc;
   var btext   = "";
   var extraoffset = isIE ? 10 : 0;
   
   if (index && name != "" && img_index < myDB.data[index].bilder.length) {
   
      btext = myDB.data[index].bilder[img_index].btext;
         
      if (imgDhtmlWrite)
         loadsrc = 'blank.html';
      
      imgWinPosX = (screen.availWidth  - (imgSizeX +imgAddX)) / 2;
      imgWinPosY = (screen.availHeight - (imgSizeY +imgAddY)) / 2;

      // Fenster öffnen
      abfallDBImg = window.open (loadsrc, 'abfallDBImg', 
         'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,dependent=yes,left=0,top=0,location=no'
         + ',width='+(imgSizeX+imgAddX+extraoffset*2)+ ',height=' +(imgSizeY+imgAddY+extraoffset)
         + ',left=' + imgWinPosX
         + ',top='  + imgWinPosY
      );

      if (abfallDBImg) {

         // Fenster-Inhalt dynamisch erzeugen mit Blättern-Funktion?
         if (imgDhtmlWrite) {
         
            var innerWidth  = get_innerWidth(abfallDBImg);
            var innerHeight = get_innerHeight(abfallDBImg);            
            var doc         = abfallDBImg.document;
                        
            doc.close();
            doc.open();
            doc.writeln('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">');            
            // doc.writeln('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">');
            doc.writeln('<html>');
            doc.writeln('<head>');
            // doc.writeln('  <title>'+btext+'</title>');
            doc.writeln('  <title>' + langspec.word.images + ' ' + myDB.data[index].avv_schluessel+' - '+myDB.data[index].bezeichnung+'</title>');
            doc.writeln('  <script type="text/javascript" language="JavaScript">');
            doc.writeln('     var abfobj    = opener.myDB.data['+index+'];');            
            doc.writeln('     var anz_img   = abfobj.bilder.length;');            
            doc.writeln('     var img_index = ' +img_index+ ';');
            doc.writeln('');
            doc.writeln('     function loc_blaettern(obj) {');
            doc.writeln('');
            doc.writeln('       var btext;');
            doc.writeln('       if (obj.id=="vor") img_index++;');
            doc.writeln('       else img_index--;');
            doc.writeln('       if (img_index > (anz_img-1)) img_index=0;');
            doc.writeln('       if (img_index < 0) img_index=anz_img-1;');            
            doc.writeln('       btext = abfobj.bilder[img_index].btext;');
            doc.writeln('       document.getElementById("img1").src = opener.pathimages+"/"+abfobj.bilder[img_index].bname;');
            doc.writeln('       document.getElementById("text1").innerHTML = " '+langspec.word.image+'&nbsp;"+(img_index+1)+" / "+anz_img+" <b>&nbsp;&nbsp;&nbsp;"+btext+"<\/b>";');
            doc.writeln('       opener.winresize();');
            doc.writeln('     }');
            doc.writeln('');
            doc.writeln('');
            doc.writeln('  </script>');
            doc.writeln('</head>');
            doc.writeln('<body>');
            doc.writeln('  <table>');
            doc.writeln('    <tr>');
            doc.writeln('      <td colspan="3"><img id="img1" src="'+imgsrc+'" alt="'+name
                                 +'" width="'+imgSizeX+'" height="'+imgSizeY
                                 +'" onclick="window.close();"></td>');
            doc.writeln('    </tr>');
            doc.writeln('    <tr>');
            doc.writeln('      <td colspan="3" style="text-align:right">&nbsp;&nbsp;');            
            doc.writeln('      </td>');
            doc.writeln('    </tr>');
            doc.writeln('    <tr>');
            doc.writeln('      <td style="width:80px; text-align:left; padding: 5px 8px 0 0;">');
            doc.writeln('        <img id="back" name="back" src="img/zurueck.gif" alt="zurueck" onclick="javascript:loc_blaettern(this);"');
            doc.writeln('             onmouseover="document.back.src=' + "'img/zurueck_glow.gif'"    + '" onmouseout="document.back.src='+"'img/zurueck.gif'" +'"');
            doc.writeln('             onmousedown="document.back.src=' + "'img/zurueck_pressed.gif'" + '" onmouseup="document.back.src='+"'img/zurueck.gif'" +'"');
            doc.writeln('        >');
            doc.writeln('        <img id="vor" name="vor" src="img/vor.gif" alt="vor" onclick="javascript:loc_blaettern(this);"');
            doc.writeln('             onmouseover="document.vor.src=' + "'img/vor_glow.gif'"    + '" onmouseout="document.vor.src='+"'img/vor.gif'" +'"');
            doc.writeln('             onmousedown="document.vor.src=' + "'img/vor_pressed.gif'" + '" onmouseup="document.vor.src='+"'img/vor.gif'" +'"');
            doc.writeln('        >');            
            doc.writeln('      </td>');
            doc.writeln('      <td colspan="2" style="text-align:left; margin-left:10px;">');
            var num_index = img_index; num_index++;
            doc.writeln('         <div id="text1">'+langspec.word.image+'&nbsp;'+num_index+' / '+myDB.data[index].bilder.length+' <b>&nbsp;&nbsp;&nbsp;'+btext+'</b></div>');            
            doc.writeln('      </td>');
            doc.writeln('    </tr>');
            // doc.writeln('    <tr>');
            // doc.writeln('      <td colspan="3" style="text-align:right">&nbsp;&nbsp;(zum Schlie&szlig;en des Fensters auf das Bild klicken)');            
            // doc.writeln('      </td>');
            // doc.writeln('    </tr>');
            doc.writeln('  </table>');
            doc.writeln('');
            
            // im IE muss body geladen sein für Setzen von Eventhandlern:
            doc.writeln('  <script type="text/javascript" language="JavaScript">');
            doc.writeln('     window.onresize = opener.winresize;');
            
            // doc.writeln('     document.getElementById("img1").width ='+(innerWidth -imgAddX)+';');
            // doc.writeln('     document.getElementById("img1").height='+(innerHeight-imgAddY)+';');
            doc.writeln('     document.getElementById("img1").width ='+imgSizeX+';');
            doc.writeln('     document.getElementById("img1").height='+imgSizeY+';');
                        
            // Fenster bekommt die Ereignisse nur bei untergeordneten Fenster-Elementen, nicht bei Drag von Fenster selbst:
            // doc.writeln('     window.onmousedown = opener.dragstart;');
            // doc.writeln('     window.onmousemove = opener.drag;');
            // doc.writeln('     window.onmouseup   = opener.dragstop;');
            
            doc.writeln('  </script>');
            
            doc.writeln('');
            doc.writeln('</body>');
            doc.writeln('</html>');
            doc.close();
            
            // abfallDBImg.onresize = winresize; // muss wegen IE im body stehen
                        
         }
         abfallDBImg.focus(); 
      }
   }
}


// ****************************************************************************
// ****************************************************************************
// Liste anzeigen   http://www.grsites.com textur:lblue010.jpg blue:ddeeee red:

function load_data (index) {
   // alert (parent.ContentFrame.location.href);
   if (parent.ContentFrame.location.href.substr(parent.ContentFrame.location.href.length-12,12) != "Abfrage.html") {
      parent.ContentFrame.location.href = "Abfrage.html";
      alert (langspec.message.data_load); // diese Meldung ist aus Timing-Gründen hier notwendig, damit zuerst alter Datensatz restauriert wird.
   }
   form_clear();
   akt_index=index;
   show_data(index);
   parent.ContentFrame.focus();
   parent.frames[1].focus();
   // Fenster schliessen, da focus setzen nicht sicher funktioniert
   abfallDBListe.close(); 
}

function make_dataline (index) {
   var avv_key = '';
   if (myDB.data[index].avv_schluessel == noAVV6)
      avv_key = langspec.BaselOecd.noAVV;
   else
      avv_key = add_blanks(myDB.data[index].avv_schluessel);
   
   var line = '<tr><td style="padding-left:20px">'
               +'<a href="javascript:opener.load_data('+index+');" title="'+langspec.title.load_data+'"><b>'+avv_key+'</b></a></td><td>'
               +myDB.data[index].avv_bezeichnung+'&nbsp;</td><td>'
               +myDB.data[index].bezeichnung+'&nbsp;</td><td>'
               +'<a href="javascript:opener.load_data('+index+');" title="'+langspec.title.load_data+'">'+myDB.data[index].basel_code+'</a>&nbsp;</td><td>'
               +'<a href="javascript:opener.load_data('+index+');" title="'+langspec.title.load_data+'">'+myDB.data[index].oecd_code+'</a>&nbsp;</td>'
               +'</tr>';
   return line;
}

function show_liste (sortfeld, sortdir) {

   var extraoffset = isIE ? 10 : 0;
   var sizeX = screen.availWidth  - 100;
   var sizeY = screen.availHeight - 100;
   
   if (sortfeld != "") {
            
      if (imgDhtmlWrite)
         loadsrc = 'blank.html';
      
      listeWinPosX = (screen.availWidth  - sizeX) / 2;
      listeWinPosY = (screen.availHeight - sizeY) / 2;

      // Fenster öffnen
      abfallDBListe = window.open (loadsrc, 'abfallDBListe', 
         'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,dependent=yes,left=0,top=0,location=no'
         + ',width='+ sizeX + ',height=' + sizeY
         + ',left=' + listeWinPosX
         + ',top='  + listeWinPosY
      );

      if (abfallDBListe) {
               
         // Fenster-Inhalt dynamisch erzeugen
         if (imgDhtmlWrite) {
         
            var innerWidth  = get_innerWidth(abfallDBListe);
            var innerHeight = get_innerHeight(abfallDBListe);            
            var doc         = abfallDBListe.document;
            
            var sortfelder   = new Array ('avv_schluessel',  'avv_bezeichnung', 'bezeichnung',     'basel_code',     'oecd_code');
            var lf = langspec.field;
            var sortfldnames = new Array (lf[sortfelder[0]], lf[sortfelder[1]], lf[sortfelder[2]], lf[sortfelder[3]], lf[sortfelder[4]]);            
            var makesortlink = new Array (true,true,true,true,true);            
            if (langspec.code == 'FR') {
               makesortlink = new Array (true,false,false,true,true);  // nicht sortieren nach avv-bez. und bez.          
            }
            
            doc.close();
            doc.open();            
            
            // ohne Angabe von DTD: "no system identifier in emitted doctype"
            // doc.writeln('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">');
            doc.writeln('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'); 
            doc.writeln('<html>');
            doc.writeln('<head>');
            doc.writeln('  <title>'+langspec.wintitle.listwin +'</title>');
            doc.writeln('  <script type="text/javascript" language="JavaScript">');
            doc.writeln('  </script>');
            doc.writeln('  <style type="text/css">');
            doc.writeln('      body{margin:0px;padding:0px;font-family:'+ffamily+';background-color:#ffffff;}');
            doc.writeln('      td{padding-left:5px;font-family:'+ffamily+';font-size:10pt}');
            doc.writeln('      a {font-family:'+ffamily+';font-size:10pt}');
            doc.writeln('      #banner {background: none repeat scroll 0 0 #F6F9FC; margin-bottom:0.9em; margin-top: 1.2em; margin-left: 1.2em;');
            doc.writeln('       padding: 0;color: #054295; font-family: Arial,helvetica; font-size: 12pt; font-weight: bold;}');            
            doc.writeln('  </style>');
            doc.writeln('</head>');
            doc.writeln('<body>');            
            doc.writeln('  <div id="banner">'+langspec.wintitle.banner+'</div>');   
            doc.writeln('  <table border="1" bgcolor="#f7f7f7">'); 
            
            // Felder der Titlezeile mit Sortierlinks
            doc.writeln('  <tr>');              
            for (var i = 0; i < sortfelder.length; i++) {   
               if (makesortlink[i]) {
                  var nextdir = 'up';
                  var title  = langspec.title.sort_by + ' ' + sortfldnames[i];
                  if (sortfelder[i] == sortfeld) {
                     if (sortdir == 'up') {
                        nextdir = 'down';
                        sortfldnames[i] += ' <img src="img/down.gif">'; // alternativ als Sonderzeichen: &or; &darr; &dArr; &nabla;
                     }
                     else {
                        sortfldnames[i] += ' <img src="img/up.gif">';   // alternativ als Sonderzeichen: &and; &uarr; &uArr; &Delta;
                     }
                  }
                  if (nextdir == 'down')
                     title = langspec.title.desc + ' '  + title;
                  else 
                     title = langspec.title.asc  + ' ' + title;                 
                  
                  doc.writeln('    <th style="padding-top:4px;padding-bottom:4px"><a href="javascript:opener.show_liste('+"'"+ sortfelder[i] +"'"  +",'"+ nextdir +"'"+')" title="'+title+'" style="font-style:'+ffamily+';font-size:12pt">'+ sortfldnames[i] +'</a></th>');
               }
               else {
                  doc.writeln('    <th style="padding-top:4px;padding-bottom:4px">' + sortfldnames[i] +'</th>');
               }
            }
            doc.writeln('  </tr>');  
            
            if (sortfeld != 'avv_schluessel' && myDB.indexorder[sortfeld]) { 
               if (sortdir == 'up') {
                  for (var i = 1; i < myDB.indexorder[sortfeld].length; i++) {
                     index = myDB.indexorder[sortfeld][i];
                     doc.writeln(make_dataline(index));                
                  }
               } // up
               else {
                  for (var i = myDB.indexorder[sortfeld].length-1; i > 0; i--) {
                     index = myDB.indexorder[sortfeld][i];
                     doc.writeln(make_dataline(index));                
                  }
               } // down
               // noch eventuelle Datensätze mit leerem Sortierfeld anhängen
               if (myDB.indexorder[sortfeld].length-1 < anz_all) {
                  for (var index = 1; index <= anz_all; index++) {
                     var fehltnoch = true;
                     for (var i = 1; i < myDB.indexorder[sortfeld].length; i++) {
                        if (myDB.indexorder[sortfeld][i] == index)
                           fehltnoch = false;
                     }
                     if (fehltnoch)
                        doc.writeln(make_dataline(index));
                  }
               }
               // alert (myDB.indexorder[sortfeld].length + '   ' + anz_all);               
            }
            // Sortierung nach avv_schluessel
            else {
               if (sortdir == 'up') {
                  for (var index = 1; index <= anz_all; index++) {
                     doc.writeln(make_dataline(index));                
                  }
               } else {
                  for (var index = anz_all; index >= 1; index--) {
                     doc.writeln(make_dataline(index));                
                  }               
               }
            }
            doc.writeln('  </table>');
            doc.writeln('</body>');
            doc.writeln('</html>');
            doc.close();
            
         }
         abfallDBListe.focus(); 
      }
   }
}


// ****************************************************************************
// ****************************************************************************
// Versions-Informationen (Client und Daten) anzeigen

function show_info() {

   var info = langspec.info.header;
       
   info += '\n' + langspec.info.datacount + ': ';
   if (myDB.info) {
      info +=  myDB.info.anzahl;
      if (myDB.info.anzahl != anz_all)
         info += " (loaded: " + anz_all + ")";
      info += '\n' + langspec.info.dataver + ': ' + myDB.info.version + ' (' + myDB.info.datum +')';
   }
   else
      info += anz_all;
   
   info += '\n' + langspec.info.programver + ': ' + version + " (" + revision.substring(1,revision.length-2)+ ")";
   
   info += '\n' + langspec.info.host + ': ';
   if (hostName) 
      info += hostName;
   else
      info += 'local';   
      
   alert (info);
}

// ****************************************************************************
// ****************************************************************************
// in den Datensätzen blättern:
//
// ausgehend von Objekt myDB.data[akt_index] und Attribut-Feld <orderby> 
// entsprechend myDB.indexorder.<orderby> und dir='vor' oder 'zurueck' 
// neuen akt_index setzen und myDB.data[akt_index] auf Objekt Bildschirm anzeigen.
// Hierbei werden auch vom Anwender veränderte Feldinhalte berücksichtigt und der entsprechende
// Datensatz angezeigt (hierbei ist die Suchrichtung egal).

function blaettern (orderby, dir) {

   var done        = false;
   // alert (akt_index);

   // ******   orderby 'index'
   if (orderby == 'index') {

      if (dir == 'vor') {
         akt_index++;
         if (akt_index > max_index)
            akt_index = 0;
      }
      else {
         akt_index--;
         if (akt_index < 0)
            akt_index = max_index;
      }      
      done = true; // neuer akt_index gesetzt
   }
   
   // ******   orderby != 'index'
   else {
   
      var index_array = myDB.indexorder[orderby];   // Array mit Index-Reihenfolge entsprechend dem Feld <orderby>
      
      // myDB.indexorder.<orderby> existiert nicht?
      if (!index_array)  
         akt_index = 0;
         
      // myDB.indexorder.<orderby> existiert
      else {
      
         // Bildschirm-Inhalt auslesen
         var ds  = new Abfall(0);
         ds.readscreen();
         
         // Datenfeld <orderby> vom Anwender verändert?  ->  erster DS entsprechend verändertem <orderby>
         if (myDB.data[akt_index][orderby] != null
               &&  ds[orderby] != myDB.data[akt_index][orderby]  
               &&  ds[orderby] != 'undefined' 
               &&  !(orderby == 'avv_schluessel' && myDB.data[akt_index].avv_schluessel == noAVV6)
            )  {
               
            var i = 0;
            while (i < index_array.length-1
               && (myDB.data[index_array[i]][orderby]).toUpperCase() < ds[orderby].toUpperCase()
               // && ((myDB.data[index_array[i]][orderby]).toUpperCase().localeCompare( ds[orderby].toUpperCase() ) < 0)
            ) {
               i++;
            }
            // alert (myDB.data[akt_index][orderby] + '  '+ds[orderby])
            akt_index = index_array[i];
            done = true;
         }
         
         // sonstige Bildschirm-Inhalte vom Anwender verändert?  ->  Original-Datensatz  anzeigen
         // if (!done && ds.compare(myDB.data[akt_index]))  {
            // alert ("Inhalte verändert!");
            // akt_index = akt_index;
            // done = true;
         // }
         
         // einfach Blättern
         if (!done) {
         
            // akt_index suchen in indexorder.<orderby> und akt_index entsprechend Suchrichtung neu setzen
            for (var i=0; i < index_array.length; i++) {  
               if (index_array[i] == akt_index) {
                  done = true;
                  // vor (falls letztes Element, wieder bei erstem anfangen)
                  if (dir == 'vor') {
                     if (i < index_array.length-1)
                        akt_index = index_array[i+1];
                     else
                        akt_index = index_array[0]; 
                  }
                  // zurück (falls erstes Element, wieder bei letztem anfangen)
                  else { 
                     if (i > 0)
                        akt_index = index_array[i-1];
                     else
                        akt_index = index_array[index_array.length-1];
                  }
                  break;
               }
            }
            
            // akt_index nicht gefunden in indexorder.<orderby> ?
            if (!done) { 
               if (dir == 'vor')
                  akt_index = index_array[1];
               else
                  akt_index = index_array[index_array.length-1];
            }
         
         }  // Bildschirm-Inhalt unverändert
      }  // index_array existiert
   }  // orderby != 'index'
         
   show_data (akt_index);
}


// ****************************************************************************
// ****************************************************************************
// Dropdown-Listen füllen aus myDB.attribute - Arrays

function fill_dropdowns() {

   for (var feld in myDB.attribute) {
      if (form[feld].length == 0)
         for (var i=0; i < myDB.attribute[feld].length; i++) {
            var NeuerEintrag = new Option(myDB.attribute[feld][i], i, false, false);
            form[feld].options[form[feld].length] = NeuerEintrag;
      }
   }
}

// ****************************************************************************
// ****************************************************************************
// Einträge setzen in Spiegel-Dropdown 

function fill_spiegel (spiegeleintrag) {

   var formfeld = form['spiegeleintrag'];
   var spiegelMitBlanks = '';
   var spiegelText = '';

   // alte Elemente entfernen
   while (formfeld.options.length)
      formfeld.options[0] = null;
         
   anz_spiegel = 0;
   SpiegelIndex = new Array();
   if (spiegeleintrag.length) {
   
      // Liste der Spiegel-AVV-Nummern, an erster Stelle der Haupt-Datensatz:
      Spiegel = (myDB.data[akt_index].avv_schluessel +',' + spiegeleintrag).split(',');
      anz_spiegel = Spiegel.length-1;
         
      // Index und avv_bezeichnung zu Spiegel suchen
      SpiegelIndex[0] = akt_index;
      spiegelText = myDB.data[akt_index].avv_bezeichnung;
   }

   // Inhalt des Datensatz-Feldes als Null-Element (avvkey mit mit Blanks)
   spiegelMitBlanks = '';
   for (var i=1; i<=anz_spiegel; i++)  {
      if (i>1)
         spiegelMitBlanks += ', ';
      spiegelMitBlanks += add_blanks(Spiegel[i]);
   }
   formfeld.options[0] = new Option (spiegelMitBlanks, 0, true, true);
   
   // Spiegeleintrag gesetzt?
   if (spiegeleintrag.length) {
      
      // zusätzliche Kopf-Einträge
      var offset = 1; 
      formfeld.options[1] = new Option('', 0, false, false);
      // formfeld.options[2] = new Option('Spiegeleinträge entsprechend AVV-Katalog: ', 0, false, false);
      
      // alle Spiegeleinträge (avv_schluessel) durchlaufen ...
      for (var sp=1; sp<=anz_spiegel; sp++) {      
         SpiegelIndex[sp] = 0;
         spiegelText  = "";
            
         // Index zu Spiegeleintrag suchen
         for (var i=1; i<=max_index; i++) {
            if (Spiegel[sp]==myDB.data[i].avv_schluessel) {
               SpiegelIndex[sp] = i;
               spiegelText  = myDB.data[i].avv_bezeichnung;
               break;
            }
         }
            
         // AVV_Bezeichnung in myDB.avv_katalog vorhanden? Dann immer diese nehmen:
         if (myDB.avv_katalog) {
            if (myDB.avv_katalog[Spiegel[sp]])
               spiegelText = myDB.avv_katalog[Spiegel[sp]];
            else
               // evtl. ohne '*' im avv_katalog?
               if (Spiegel[sp].length > 6  &&  myDB.avv_katalog[Spiegel[sp].substr(0,6)])
                  spiegelText = myDB.avv_katalog[Spiegel[sp].substr(0,6)];
         }
   
         // Langform-Einträge in Dropdown setzen
         var sptext = add_blanks(Spiegel[sp]) + ' - ';
         var hint   = spiegelText;  
         sptext += spiegelText;
         if (SpiegelIndex[sp]) {
            sptext += langspec.text.datasetShow;
            hint   += langspec.title.datasetShow;
         }
         else { 
            sptext += langspec.text.datasetNone;
            hint   += langspec.title.datasetNone;
         }
         formfeld.options[sp+offset] = new Option(sptext, SpiegelIndex[sp], false, false);
         // Text als Tool-Tipp setzen
         formfeld.options[sp+offset].title = hint;
         // falls vorhanden, Eintrag blau setzen
         if (SpiegelIndex[sp]) 
            formfeld.options[sp+offset].style.color = "#0000ff";
            
      }
      
      // wegen der besseren Optik noch einen Leereintrag am Ende
      formfeld.options[formfeld.length] = new Option('', 0, false, false);
   } else {
      // // kein Spiegeleintrag - dummy mit Text setzen sonst ist das Feld kleiner und die Anzeige tanzt !!! (blanks reichen nicht)
      formfeld.options[1] = new Option(langspec.text.noEntry, 0, false, false);
      formfeld.options[1].style.color = "#000000";
   }   
}

// ****************************************************************************
// ****************************************************************************
// Anzeige von Suchergebnis "gefunden: x (n)"

function fill_gefunden () {

   var str_gef = ' '+akt_gefunden;
   
   if (anz_gefunden > 0) {
      str_gef += ' / ' +anz_gefunden;
      form.gefunden.value = str_gef;
   }
}

// ****************************************************************************
// ****************************************************************************
// Infolinks setzen bzw. entfernen

function clear_infolinks () {
   
   for (var feld in checkDB.data[0]) {
      var maskfld = parent.ContentFrame.document.getElementById('info_' + feld);
      if (maskfld) {
         maskfld.style.visibility  = 'hidden';         
      }
   }   
}


function set_infolinks (index) {
    
   clear_infolinks ();
   var ds = myDB.data[index];
   var isnoAVV = (ds.avv_schluessel == noAVV6)
          
   if (ds.info_links) {
      var anz = ds.info_links.length;  

      // automatischer zusatz-info-button bei noAVV
      if (isnoAVV) {
         if (! (anz && ds.info_links[anz-1].zufeld == "05 zusatz")) {
                  
            ds.info_links[anz] =  {
               "anzeigetext" : "",
               "link_extern" : "",
               "link_intern" : "",
               "wichtig_fld" : "",
               "zufeld"      : "05 zusatz"
            };         
            ds.info_links[anz].anzeigetext = langspec.BaselOecd.tooltip;
            ds.info_links[anz].link_intern = langspec.BaselOecd.pdf;
            
            anz++;
         }
      }
      
      if (anz) {
         for (var i=0; i<anz; i++) {
         
            var maskfld = parent.ContentFrame.document.getElementById('info_' + ds.info_links[i].zufeld.substr(3));            
            // var infolink = '<a target="_blank" href="' + pathpdf + '/';
            var infolink = '<a href="javascript:parent.HeaderFrame.open_pdf_win(' + "'" + pathpdf + '/';
            
            if (maskfld) {
                infolink += ds.info_links[i].link_intern ? ds.info_links[i].link_intern : ds.info_links[i].link_extern;
                infolink += "'" +');"><img style="border:none" src="';
                infolink += ds.info_links[i].wichtig_fld ? 'img/info_rot.gif' : 'img/info_blau.gif';
                infolink += '" onmouseover="this.src=';
                infolink += ds.info_links[i].wichtig_fld ? "'img/info_rot_glow.gif'" : "'img/info_blau_glow.gif'";
                infolink += '" onmouseout="this.src=';
                infolink += ds.info_links[i].wichtig_fld ? "'img/info_rot.gif'" : "'img/info_blau.gif'";
                infolink += '" onmousedown="this.src=';
                infolink += ds.info_links[i].wichtig_fld ? "'img/info_rot_pressed.gif'" : "'img/info_blau_pressed.gif'";
                infolink += '" onmouseup="this.src=';
                infolink += ds.info_links[i].wichtig_fld ? "'img/info_rot.gif'" : "'img/info_blau.gif'";
                infolink += '" alt="zusatz info" title="';
                infolink += ds.info_links[i].anzeigetext;
                infolink += '"></a>';
            
                maskfld.innerHTML = infolink;
                maskfld.style.visibility  = 'visible';
            }
         }
      }   
   }                     
}


// ****************************************************************************
// ****************************************************************************
// Thumbnails anzeigen

function fill_thumbs (index) {

    var ds      = myDB.data[index];
    var anzimg  = ds.bilder.length;
    var thumbsfld = parent.ContentFrame.document.getElementById('thumbsinfo');
    if (!thumbsfld)
        thumbsfld = document.all.thumbsinfo;

    if (anzimg)
        thumbsfld.innerHTML = '<font style="'+class_smalltext+'" color="'+info_color+'">'+langspec.text.imgheader+'</font>';
    else
        thumbsfld.innerHTML = '<font style="'+class_smalltext+'">&nbsp;</font>';
   
    var thumbs = parent.ContentFrame.document.getElementById('thumbs');
    if (!thumbs)
        thumbs = document.all.thumbs;

    // alle thumbnail-Elemente in Maske durchgehen
   
    var colover = '#054295';  // highlite mouseover
    var colstd  = '#ffffff';  // standard mouseout
    var thumbsHTML = '';

    var maximg = anzimg;
    if (isIE && anzimg < 12)
       maximg = 12; // für IE immer feste Image-Anzahl, sonst jitter in der Ansicht
    
    thumbsHTML += '<table><tr><td>';
    
    for (var i=0; i<maximg; i++) {
      
      if (i==6)
         thumbsHTML += '</td></tr><tr><td>';
      if (i < anzimg) {
         thumbsHTML += '<img name="thumb'+i+'"';
         thumbsHTML += ' alt="'+ds.bilder[i].bname+'"';
         thumbsHTML += (ds.bilder[i].btext) ? ' title="'+ds.bilder[i].btext+'"' : ' title="'+ds.bilder[i].bname+'"';
         thumbsHTML += ' src="'+paththumbs+'/'+ds.bilder[i].bname+'"';
         thumbsHTML += ' onclick="loc_show_img(this)"';
         thumbsHTML += ' width="60" height="40"';
         thumbsHTML += ' onmouseover="this.style.borderColor='+"'"+colover+"'"+'"';        
         thumbsHTML += ' onmouseout ="this.style.borderColor='+"'"+colstd +"'"+'"';        
         thumbsHTML += ' style="border:2px; border-style:solid; border-color:'+colstd+'; margin-right:2px;"';
         thumbsHTML += '>';
      }
      else {
         thumbsHTML += '<img name="thumb'+i+'"';
         // thumbsHTML += ' src="img/thumb_blank.jpg"';
         thumbsHTML += ' src="img/thumb_blank_trans.gif"';
         thumbsHTML += ' width="60" height="40"';
         thumbsHTML += ' style="padding:2px; margin-right:2px;"';
         thumbsHTML += '>';
      }
    }
    thumbsHTML += '</td></tr></table>';
    
    thumbs.innerHTML = thumbsHTML;   
}

// ****************************************************************************
// ****************************************************************************
// Verfahren für grenzüberschreitenden Transport anzeigen

function openwin_grenz_verfahren () {
   var breite = 900;
   var hoehe  = 680;   
   var scrollbars = 'yes';
   if (showStaatenBlock) {
      hoehe += 200;
      scrollbars = 'yes';
   }
   
   var links  = screen.width/2  - breite/2;
   var oben   = screen.height/2 - hoehe/2;
   
   if (grenzWin)
      grenzWin.close();
   grenzWin = window.open(
            "grenz_verfahren.html", "Titel", 
            "width="+breite+",height="+hoehe+",top="+oben+",left="+links+
            ",scrollbars="+scrollbars+
            ",toolbar=no,location=no");
   grenzWin.focus(); 
}


function set_grenz_verfahren (index) {
   var ds   = myDB.data[index];
   var elem = parent.ContentFrame.document.getElementById('grenz_verfahren');
   var info = parent.ContentFrame.document.getElementById('info_einstufung');
   
   if (!index) {
      info.innerHTML = '';
   }
   else if (ds.einstufung != '') {
      var einstufung = ds.einstufung.charAt(0);
      elem.style.visibility = 'visible';
      // info.innerHTML = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + langspec.text.classification + ': ' + langspec.classification[einstufung]; 
      info.innerHTML = ' ';
   }
   else {
      elem.style.visibility = 'hidden';
      info.innerHTML = '  ' + langspec.classification[0]; 
   }
}

// Link zum Verfahren für grenzüberschreitenden Transport entfernen
function clear_grenz_verfahren() {
  parent.ContentFrame.document.getElementById('grenz_verfahren').style.visibility = 'hidden';      
}

// ****************************************************************************
// ****************************************************************************
// letztes Suchmuster anzeigen

function show_suchmuster() {

   akt_index = 0;
   show_data(akt_index);
   if (SuchMuster) {
      SuchMuster.writescreen();
   }
}

// ****************************************************************************
// ****************************************************************************
// Datensatz entsprechend Inhalt des Bildschirm-Formulars suchen

function suchen(fld,show_msg) {

   Ergebnis = new Array ();
   Ergebnis[0] = 0;
   anz_gefunden = 0;
   akt_gefunden = 0;
   
   akt_index = 0;
   
   if (true) {
      // *******************************************************************
      // Suchparameter einlesen und auswerten

      var changed = 0;

      // globales Objekt
      SuchMuster = new Abfall(0);            
      
      if (fld == 'all') 
         SuchMuster.readscreen();
      else if (fld == 'avv_schluessel')
         SuchMuster.avv_schluessel = strip_blanks(form['avv_schluessel'].value);  // Suche nur auf Feld avv_schluessel
      else if (fld == 'basel_code')
         SuchMuster.basel_code = form['basel_code'].value;  // Suche nur auf Feld basel_code
      else if (fld == 'oecd_code')
         SuchMuster.oecd_code  = form['oecd_code'].value;  // Suche nur auf Feld oecd_code
      else
         SuchMuster.readscreen(); // Suche auf alle Felder: 
                  
      changed = SuchMuster.compare (checkDB.data[0]);
      
      // keine Suchkriterien -> alle Datensätze als Ergebnis 
      if (changed == 0) {
         for (var i=1; i<=max_index; i++)
            Ergebnis[i] = i;
      }
      // ansonsten alle Datensätze entsprechend den Suchkriterien prüfen 
      else {
         for (var i=1; i<=max_index; i++) {
            // alle Felder von SuchMuster sind Teilstrings von myDB.data[i] ? 
            if (SuchMuster.compare(myDB.data[i]) >= 0) {
               anz_gefunden++;
               Ergebnis[anz_gefunden] = i;
            }
         }
      }
      
      anz_gefunden = Ergebnis.length - 1;
      
      // *******************************************************************
      // Ergebnis anzeigen
      
      if (anz_gefunden) { 
         akt_gefunden = 1;
         akt_index = Ergebnis[akt_gefunden];
         if (anz_gefunden > 1) {
            if (fld && fld != 'all')
               alert (''+ anz_gefunden +' '+langspec.word.datasets +' '+ langspec.word.found 
                  +' '+ langspec.word.with_ +' '+ langspec.field[fld] +' '+ SuchMuster[fld]);
            else
               alert (''+ anz_gefunden +' '+langspec.word.datasets +' '+ langspec.word.found);
         }
      }
      else {
         akt_index = 0;
         akt_gefunden = 0;
         if (fld && fld != 'all')
            alert (langspec.message.nodatafor +' '+ langspec.field[fld] +' '+ SuchMuster[fld]+ '!');
         else
            alert (langspec.message.nodatafound);
         form_clear();
      }
      show_data (akt_index);   
         
      // *******************************************************************
      
      show_gefunden();
   }
         
   return anz_gefunden;
}

// ****************************************************************************
// ****************************************************************************
// In Such-Ergebnissen blättern

function ergebnis_blaettern (dir) {
   
   if (!anz_gefunden || !Ergebnis.length) {
      // alert ('Es liegen keine Suchergebnisse vor!');
      return 1;
   }
   
   // nur blättern, falls aktueller Datensatz das aktuelle Suchergebnis ist 
   //          (ansonsten einfach wieder das aktuelle Suchergebnis anzeigen) 
   if (akt_index == Ergebnis[akt_gefunden]) {
      // vor (mit Null-Durchlauf)
      if (dir == 'vor') {
         if (akt_gefunden < anz_gefunden)
            akt_gefunden++;
         else
            // akt_gefunden = 0; // auch Element 0 anzeigen
            akt_gefunden = 1;    // Null-Durchlauf ohne Element 0
      }
      // zurück (mit Null-Durchlauf)
      else {
         // if (akt_gefunden > 0)  // auch Element 0 anzeigen
         if (akt_gefunden > 1)     // Null-Durchlauf ohne Element 0
            akt_gefunden--;   
         else
            akt_gefunden = anz_gefunden;
      }
   }
   
   fill_gefunden ();
   
   akt_index = Ergebnis[akt_gefunden];
   show_data (akt_index);
   
   return 0;
}

// ****************************************************************************
// ****************************************************************************
// Spiegel in Selectbox auswählen

function spiegel_select() {

   var text = form.spiegeleintrag.options[form.spiegeleintrag.selectedIndex].text;   
   // Datensatz vorhanden?
   if (form.spiegeleintrag.value > 0) {
      akt_index = form.spiegeleintrag.value;
      show_data (akt_index);
   }
   // sonst Selectbox wieder auf erstes Element stellen
   else {
      // alert (text);      // Anzeige der AVV-Bezeichnung
      form.spiegeleintrag.selectedIndex = 0;
   }
}

// ****************************************************************************
// ****************************************************************************
// Daten-Konsistenz des myDB-Objektes checken -> bricht beim ersten Fehler ab

function check_data() {

   var ok = true;
   var err = 'check_data ERROR: \n';
      
   // In myDB-Objekt alle Elemente entsprechend checkDB-Objekt vorhanden ? 
   // Basis-Objekte
   for (var basObj in checkDB) {             
      // alert ("basObj=" + basObj);
      if (ok && !myDB[basObj]) {
         ok = false;
         alert (err + 'myDB.' +basObj+ ' existiert nicht!');
      }
      else {
         // Unter-Objekte
         for (var uObj in checkDB[basObj]) {    
            // alert ('check '+basObj+ '.' + uObj);
            if (myDB[basObj][uObj]) {
               // alert ('check ok - vorhanden: myDB.' +basObj+ '.' +uObj+ '=' +myDB[basObj][uObj]);
            }
            else {
               ok = false;
               alert (err + ' myDB.' +basObj+ '.' +uObj+ ' existiert nicht!');
               break;
            }
         }
      }
   }
   
   // Anzahl der eingelesenen Elemente des 'data'-Arrays stimmt überein mit 'info.anzahl' ?
   if (ok && myDB.info.anzahl != anz_all) {
      ok = false;
      alert (err + "myDB.info.anzahl = " + myDB.info.anzahl + ' Datensätze, geladen: ' + anz_all);
   }
      
   // jeweils erster indexorder-Index   myDB.indexorder[feld][0] == 0 ?
   if (ok) {
      for (var feld in myDB.indexorder) {
         if (myDB.indexorder[feld][0] != 0) {
            ok = false;
            alert (err+ 'myDB.indexorder.' +feld+ '[0] = ' +myDB.indexorder[feld][0]+ ' (sollte 0 sein!)');
         }
      }
   }
   
   // Alle myDB.data - Datensätze durchgehen: 
   var Anzahl = new Object();
   if (ok)  {
      for (var i=1; i<=max_index; i++) {
         // alle Felder des Datensatzes vorhanden ?
         if (ok) for (var feld in checkDB.data[0]) {
            if (myDB.data[i][feld] == null) {
               ok = false;
               alert (err+ 'myDB.data[' +i+ '].' +feld+ ' nicht vorhanden!');
            }
         }
         // Dropdown-Attribute in Attribut-Liste enthalten ?
         if (ok) for (var feld in myDB.attribute) {
            // if (i==1) alert (feld);  // farbe, konsistenz, geruch
            // if (i==1) alert (myDB.data[i][feld]); // schwarz, ohne, fest
            var found = false;
            for (var j=0; j<myDB.attribute[feld].length; j++)
               if (myDB.data[i][feld] == myDB.attribute[feld][j])
                  found = true;
            if (!found) {
               ok = false;
               alert (err+ 'myDB.data[' +i+ '].' +feld+ '="' +myDB.data[i][feld]+ '" nicht gefunden in myDB.attribute.' +feld);
               break;
            }
         }
         // pro Feldname Gesamt-Anzahl der nicht leeren Felder aller Datensätze ermitteln         
         for (var feld in myDB.data[i]) {
            if (Anzahl[feld]==null) Anzahl[feld] = 0;
            if (myDB.data[i][feld]) Anzahl[feld]++;
         }
         // Arrays bilder[] und info_links[] prüfen XXX
         var ds = myDB.data[i];
         var anz = ds.bilder.length;
         for (var b=0; b<anz; b++) {
            if (!ds.bilder[b].bname)
               alert (ds.avv_schluessel+'.'+'bilder['+b+'].bname fehlt!');
            if (!ds.bilder[b].btext)
               alert (ds.avv_schluessel+'.'+'bilder['+b+'].btext fehlt!');
         }
         var anz = ds.info_links.length;
         for (var b=0; b<anz; b++) {
            if (!ds.info_links[b].anzeigetext)
               alert (ds.avv_schluessel+'.'+'info_links['+b+'].anzeigetext fehlt!');
            if (!ds.info_links[b].zufeld)
               alert (ds.avv_schluessel+'.'+'info_links['+b+'].zufeld fehlt!');
            else {
               var feldnr = parseInt(ds.info_links[b].zufeld.substr(1,1));
               if (!feldnr)
                  alert (ds.avv_schluessel+'.'+'info_links['+b+'].zufeld ungültig!');
            }
         }
      }
   }
   // Pflichtfelder (s.o.) in allen Datensätzen gesetzt ?
   if (ok) for (var i in pflichtFelder) {
      var feld = pflichtFelder[i];
      if (Anzahl[feld] != anz_all) {
         ok = false;
         alert (err+ 'Bei ' +(anz_all-Anzahl[feld])+ ' Datensätz(en) ist das Pflichtfeld ' +feld+ ' leer!');
         break;
      }
   }
   // Anzahl der Einträge der indexorder-Arrays entspricht Anzahl der gefüllten Felder in den data-Objekten ?
   if (ok) for (var feld in myDB.indexorder) {
      var indexanz = myDB.indexorder[feld].length-1;
      if (indexanz != Anzahl[feld]) {
         ok = false;
         alert (err+ 'myDB.indexorder.' +feld+ ' hat '+indexanz+' Einträge. Die Eigenschaft ' +feld+ ' ist aber in ' +Anzahl[feld]+ ' Datensätzen gesetzt.');
      }
   }
   
   return ok;
}

// ****************************************************************************
// ****************************************************************************
// Sonderfelder Suchen anzeigen

function show_gefunden() {

   if (hideSeekButton) {
      form.back_gef.style.visibility = 'hidden';
      form.vor_gef.style.visibility  = 'hidden';
      form.gefunden.style.visibility = 'hidden';
   }
   else {

      form.gefunden.style.visibility  = 'visible';
      fill_gefunden ();
      
      // Buttons verstecken?
      if (hide_buttons) {
         form.back_gef.style.visibility  = (anz_gefunden > 0) ? 'visible' : 'hidden';
         form.vor_gef.style.visibility   = (anz_gefunden > 0) ? 'visible' : 'hidden';
      }
      // sonst aktivieren/deaktivieren
      else {
         if (anz_gefunden > 0) {
            form.back_gef.title = langspec.title.back_gef;
            form.vor_gef.title  = langspec.title.vor_gef;
            form.back_gef.alt = langspec.title.back_gef;
            form.vor_gef.alt  = langspec.title.vor_gef;
         }
         else {
            form.back_gef.src = 'img/zurueck_d.gif';
            form.vor_gef.src  = 'img/vor_d.gif';
            form.back_gef.title = "";
            form.vor_gef.title  = "";
         }
      } 
   }
}


// ****************************************************************************
// ****************************************************************************
// Sonderfelder Suchen deaktivieren

function hide_gefunden() {

   form.gefunden.value             = '';
   form.gefunden.style.visibility  = 'hidden';

   // Buttons unsichtbar setzen ?
   if (hide_buttons) {
      form.back_gef.style.visibility  = 'hidden';
      form.vor_gef.style.visibility   = 'hidden';
   }
   // sonst Buttons 'deaktiviert' setzen
   else {
      form.back_gef.src  = 'img/zurueck_d.gif';
      form.vor_gef.src   = 'img/vor_d.gif';
   }
   
   Ergebnis = new Array();
   Ergebnis[0] = 0;
}


// ****************************************************************************
// ****************************************************************************
// Bildschirm-Formular leeren

function form_clear() {

   akt_index = 0;
   
   anz_gefunden  = 0;
   akt_gefunden  = 0;

   hide_gefunden();
   clear_infolinks ();
   clear_grenz_verfahren();

   setActiveFld ('avv_schluessel');

   show_data (akt_index);
}

// ****************************************************************************
// ****************************************************************************
// Tastatureingaben behandeln

function KeyPressed (e)
{
   var Taste = String.fromCharCode(e.keyCode);
   
   // alert ('KeyPressed():\nkeycode = '+e.keyCode + '\nfromCharCode() = ' + Taste);
   
   // Behandlung nach Keycodes
   switch (e.keyCode) {
   
      case 13: // Enter
         blaettern (activeFld, 'vor');
         break;
         
      case 33: // PgUp
         blaettern (activeFld, 'zurueck');
         break;
         
      case 34: // PgDn
         blaettern (activeFld, 'vor');
         break;
                  
      case 37: // Pfeil links 
         break;
         
      case 39: // Pfeil rechts
         break;
         
      case 46: // Entf (Del)
            form_clear();
         break;
      
      // wenn Keycode nicht dabei Behandlung nach Taste
      default:
         switch (Taste) {
            case 'S': // suchen('avv_schluessel',true);
               break;
               
            default:
               break;
         }
        
   }   
   
   // true = an die Windows-Standardverarbeitung weitergeben / false = Behandlung beenden
   return true; 
}

// ****************************************************************************
// ****************************************************************************

function setActiveFld (setfld) {

   if (setfld in checkDB.indexorder) {
   
      activeFld = setfld;
      // alert ("setActiveFld = " + setfld);
      for (var elem in checkDB.indexorder) {
         var fld = parent.ContentFrame.document.getElementById(elem+'_name');
         if (fld) {
            var color = '#000000';
            if (elem == setfld)
               color = info_color;      
            fld.style.color = color;      
         }
      }
   }   
}


// ****************************************************************************
// ****************************************************************************

function show_JSON () {

   var extraoffset = isIE ? 10 : 0;
   var sizeX = screen.availWidth  - 100;
   var sizeY = screen.availHeight - 100;
   var loadsrc = 'blank.html';
   var myJSON = FormatJSON (myDB);
   
   myJSON = myJSON.replace(/xxxx/g, "/n");
                
      
   imgWinPosX = (screen.availWidth  - sizeX) / 2;
   imgWinPosY = (screen.availHeight - sizeY) / 2;

   // alert (myJSON);

   // Fenster öffnen
   winJSON = window.open (loadsrc, 'JSON', 
         'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,dependent=yes,left=0,top=0,location=no'
         + ',width='+ sizeX + ',height=' + sizeY
         + ',left=' + imgWinPosX
         + ',top='  + imgWinPosY
      );

   if (winJSON) {
               
      // Fenster-Inhalt dynamisch erzeugen
      if (imgDhtmlWrite) {
         
         var innerWidth  = get_innerWidth(winJSON);
         var innerHeight = get_innerHeight(winJSON);            
         var doc         = winJSON.document;
            
         doc.close();
         doc.open();            
            
         // ohne Angabe von DTD: "no system identifier in emitted doctype"
         // doc.writeln('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">');
         doc.writeln('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'); 
         doc.writeln('<html>');
         doc.writeln('<head>');
         doc.writeln('  <title>JSON</title>');
         doc.writeln('  <script type="text/javascript" language="JavaScript">');
         doc.writeln('  </script>');
         doc.writeln('  <style type="text/css">');
         doc.writeln('      body{margin:0px;padding:0px;font-family:'+ffamily+';background-color:#ffffff;}');
         doc.writeln('      td{padding-left:5px;font-family:'+ffamily+';font-size:10pt}');
         doc.writeln('      a {font-family:'+ffamily+';font-size:10pt}');
         doc.writeln('      #banner {background: none repeat scroll 0 0 #F6F9FC; margin-bottom:0.9em; margin-top: 1.2em; margin-left: 1.2em;');
         doc.writeln('       padding: 0;color: #054295; font-family: Arial,helvetica; font-size: 12pt; font-weight: bold;}');            
         doc.writeln('  </style>');
         doc.writeln('</head>');
         doc.writeln('<body>');            
         doc.writeln('  <div id="banner">'+langspec.wintitle.banner+'</div>');   
         doc.writeln('  <pre>');
         doc.writeln(myJSON);
         doc.writeln('  </pre>');
         doc.writeln('</body>');
         doc.writeln('</html>');
         doc.close();
      
         winJSON.focus(); 
      }
   }
}

// ****************************************************************************
// ****************************************************************************
// JSON formatieren

function FormatJSON(oData, sIndent) {
    if (arguments.length < 2) {
        var sIndent = "";
    }
    var sIndentStyle = "    ";
    var sDataType = RealTypeOf(oData);

    // open object
    if (sDataType == "array") {
        if (oData.length == 0) {
            return "[]";
        }
        var sHTML = "[";
    } else {
        var iCount = 0;
        $.each(oData, function() {
            iCount++;
            return;
        });
        if (iCount == 0) { // object is empty
            return "{}";
        }
        var sHTML = "{";
    }

    // loop through items
    var iCount = 0;
    $.each(oData, function(sKey, vValue) {
        if (iCount > 0) {
            sHTML += ",";
        }
        if (sDataType == "array") {
            sHTML += ("\n" + sIndent + sIndentStyle);
        } else {
            sHTML += ("\n" + sIndent + sIndentStyle + "\"" + sKey + "\"" + ": ");
        }

        // display relevant data type
        switch (RealTypeOf(vValue)) {
            case "array":
            case "object":
                sHTML += FormatJSON(vValue, (sIndent + sIndentStyle));
                break;
            case "boolean":
            case "number":
                sHTML += vValue.toString();
                break;
            case "null":
                sHTML += "null";
                break;
            case "string":
                sHTML += ("\"" + vValue + "\"");
                break;
            default:
                sHTML += ("TYPEOF: " + typeof(vValue));
        }

        // loop
        iCount++;
    });

    // close object
    if (sDataType == "array") {
        sHTML += ("\n" + sIndent + "]");
    } else {
        sHTML += ("\n" + sIndent + "}");
    }

    // return
    return sHTML;
}


function RealTypeOf(v) {
  if (typeof(v) == "object") {
    if (v === null) return "null";
    if (v.constructor == (new Array).constructor) return "array";
    if (v.constructor == (new Date).constructor) return "date";
    if (v.constructor == (new RegExp).constructor) return "regex";
    return "object";
  }
  return typeof(v);
}


// ****************************************************************************
// ****************************************************************************

function language_init (code) {

   parent.document.title = langspec.wintitle.mainwin;
   if (!isIE || document.getElementById("Info")) {
      if (code != 'DE') {
         var bannersize = '+2';
         if (code == 'FR') {
            bannersize = '+1';         
         }         
         document.getElementById('bannerbox').innerHTML = '<div style="margin-top:15px;"><font color="#054295" size="'+bannersize+'">&nbsp;&nbsp;&nbsp;'+langspec.wintitle.banner+'</font></div>';
         parent.ContentFrame.document.getElementById('banner').style.display = 'none';
      }
      document.getElementById("Download").innerHTML  = langspec.menu.download;
      document.getElementById("Impressum").innerHTML = langspec.menu.imprint;
      document.getElementById("Kontakt").innerHTML   = langspec.menu.contact;

      document.getElementById("Download").title  = langspec.title.download;

      document.getElementById("Abfrage").innerHTML = langspec.menu.query;
      document.getElementById("Liste").innerHTML   = langspec.menu.list;
      document.getElementById("Hilfe").innerHTML   = langspec.menu.help;
      document.getElementById("Info").innerHTML    = langspec.menu.info;
   
      document.getElementById("Abfrage").title  = langspec.title.query;
      document.getElementById("Liste").title    = langspec.title.list;
      document.getElementById("Hilfe").title    = langspec.title.help;
      document.getElementById("Info").title     = langspec.title.info;

      document.getElementById("QueryString").value  = langspec.text.searchterm;
      document.getElementById("SearchSubmit").value = langspec.button.searchsubmit;
      document.getElementById("SearchSubmit").title = langspec.title.searchsubmit;
   }

   if (form) {
   
      var doc = parent.ContentFrame.document;
   
      doc.getElementById("btn_clear").value  = langspec.button.btn_clear;
      doc.getElementById("btn_clear").title  = langspec.title.btn_clear;      
      doc.getElementById("btn_seek").value  = langspec.button.btn_seek;
      doc.getElementById("btn_seek").title  = langspec.title.btn_seek;
      doc.getElementById("grenz_verfahren").value = langspec.button.grenz_verfahren;
      doc.getElementById("grenz_verfahren").title = langspec.title.grenz_verfahren;
      
      doc.getElementById("avv_kapitel_name").innerHTML  = langspec.field.avv_kapitel;
      doc.getElementById("avv_gruppe_name").innerHTML   = langspec.field.avv_gruppe;
      doc.getElementById("avv_schluessel_name").innerHTML   = langspec.field.avv_schluessel;
      doc.getElementById("avv_bezeichnung_name").innerHTML  = langspec.field.avv_bezeichnung;
      doc.getElementById("spiegeleintrag_name").innerHTML   = langspec.field.spiegeleintrag;
      doc.getElementById("bezeichnung_name").innerHTML  = langspec.field.bezeichnung;
      doc.getElementById("zusatz_name").innerHTML       = langspec.field.zusatz;
      doc.getElementById("konsistenz_name").innerHTML   = langspec.field.konsistenz;
      doc.getElementById("farbe_name").innerHTML        = langspec.field.farbe;
      doc.getElementById("geruch_name").innerHTML       = langspec.field.geruch;
      doc.getElementById("basel_code_name").innerHTML   = langspec.field.basel_code;
      doc.getElementById("oecd_code_name").innerHTML    = langspec.field.oecd_code;
      doc.getElementById("anhang_nr_name").innerHTML    = langspec.field.anhang_nr;
   }
}


// ****************************************************************************
// ****************************************************************************
// indexorder prüfen und wenn nötig neu erzeugen


function do_data_completion() {

   var anzDS     = myDB.data.length-1; // Anzahl DS ohne Null-DS   
   var indexall  = new Array();   
   for (var i=1; i<=anzDS; i++)   // Original-Indexliste entsprechend data erzeugen ohne Null-Element (1,2,3,4...)
      indexall.push(i); 
   
   // fehlende avv_bezeichnung aus avv_katalog ergänzen
   for (var i=1; i<=anzDS; i++) {
      if (myDB.data[i].avv_bezeichnung == "")
         myDB.data[i].avv_bezeichnung = myDB.avv_katalog[myDB.data[i].avv_schluessel];
   }
   
   // Anzahl in info setzen
   myDB.info.anzahl = anzDS;   
   
   // fehlende indexorder erzeugen
   for (var feld in checkDB.indexorder) {
      
      // Index-Sortierreihenfolge entsprechend Feld, Leerfelder werden nach hinten einsortiert!
      function specialSort (i1,i2) {
         var retval; // i1=i2 : 0,  i1>i2 : 1, i1<i2 : -1
         var val1 = myDB.data[i1][feld].toLowerCase();
         var val2 = myDB.data[i2][feld].toLowerCase();
         
         if (feld=='oecd_code' || feld=='basel_code') {
            if (val1.charAt(0) == '(')
               val1 = val1.substr(1);
            if (val2.charAt(0) == '(')
               val2 = val2.substr(1);               
         }
         
         if (val1 == val2)     retval = 0;
         else if (val1 == "")  retval = 1;
         else if (val2 == "")  retval = -1
         else if (val1 > val2) retval = 1;
         else                  retval = -1;
         return retval;
      }
      
      // für dieses Feld indexorder neu erzeugen?
      if (!myDB.indexorder[feld] || (myDB.indexorder[feld].length < anzDS && myDB.indexorder[feld].length < 2)) {
         
         var newsort = indexall;
         newsort.sort(specialSort);
         myDB.indexorder[feld] = new Array(0);
         myDB.indexorder[feld][0] = 0;
         myDB.indexorder[feld] = myDB.indexorder[feld].concat(newsort);
         
         // alert ("indexorder " + feld + ': ' + myDB.indexorder[feld].join(','));
      }
   }
   
   // lokale Staatennamen aus States_XX einlesen und order erzeugen
   // funktioniert hier nur, wenn schon im Header Staaten.js und language/XX/States.js eingelesen werden
   // (dann aber IE zu langsam bei Zugriff von Grenzverfahrens-Window)
   
}

// ****************************************************************************
// ****************************************************************************
// Initialisierung wird aufgerufen im onload von Header.html und Abfrage.html

function init (by) {

   form = parent.ContentFrame.document.Form1;
   
   if (parent.KontrollStaat)
      Staat.control = parent.KontrollStaat;

   if (parent.showStaatenBlock)
      showStaatenBlock = true;

   if (parent.showOrganisations)
      showOrganisations = true;
      
   do_data_completion();

   if (form)  {

      hide_gefunden();   

      if (hideSeekButton) 
         parent.ContentFrame.document.getElementById('btn_seek').style.visibility = 'hidden';
         
      parent.ContentFrame.document.getElementById('back_gef').title = langspec.title.back_gef;
      parent.ContentFrame.document.getElementById('vor_gef').title  = langspec.title.vor_gef;    
            
      parent.ContentFrame.document.getElementById('banner').innerHTML  = langspec.wintitle.banner;
            
      // Blätter-Buttons nur aktivieren wenn indexorder gefüllt
      for (var feld in checkDB.indexorder) {
         form['back_'+feld].style.visibility = 'hidden';
         form['vor_'+feld].style.visibility  = 'hidden';
         // nur Null-Element?
         if (myDB.indexorder[feld]) {
            if (myDB.indexorder[feld].length > 1) {
               form['back_'+feld].src = 'img/zurueck.gif';
               form['vor_' +feld].src = 'img/vor.gif';
               form['back_'+feld].title = langspec.title.back;
               form['vor_' +feld].title = langspec.title.forward; 
               
               form['back_'+feld].style.visibility = 'visible';
               form['vor_'+feld].style.visibility  = 'visible';
            }
         }
      }
      setActiveFld('avv_schluessel');
      parent.ContentFrame.focus();

      // initialer Aufruf?
      if (by == 'header') {

         parent.HeaderFrame.document.getElementById('show_gefunden').style.display = 'none';
         parent.HeaderFrame.document.getElementById('go_left').style.display = 'none';
         parent.HeaderFrame.document.getElementById('go_right').style.display = 'none';
         
         parent.HeaderFrame.document.getElementById('go_left').title  = langspec.title.back_gef;
         parent.HeaderFrame.document.getElementById('go_right').title = langspec.title.vor_gef;
         
         if (document.location.host == 'www.hlug.de'  || document.location.host == 'abfalltransportdatenbank.hlug.de' || hostName == 'saturn2' || hostName == 'localhost:8017') {
         
            parent.HeaderFrame.document.getElementById("Download").href = "zip/abfall_offline_client.zip";
            
            // if (location.href.search(/test/) != -1) 
            //    parent.HeaderFrame.document.getElementById("Download").href = "../../zip/abfall_offline_test.zip";
            
         } else {
            // auch bei Offline-Betrieb aktiv.
            parent.HeaderFrame.document.getElementById("Download").href = download_zip;            
         }
         
         if (langspec.code == 'FR') {
            parent.HeaderFrame.document.getElementById("Kontakt").style.visibility = 'hidden';
            parent.HeaderFrame.document.getElementById("Kontakt_Divider").style.visibility = 'hidden';            
         }
            
         initdone = 1;
            
         form_clear();
         
         for (var i=1; i<=anz_all; i++) {
            // Bildtexte auf Bildname setzen falls leer
            for (var b=0; b<myDB.data[i].bilder.length; b++) {
               if (myDB.data[i].bilder[b].btext == '')
                  myDB.data[i].bilder[b].btext = myDB.data[i].bilder[b].bname;
            }
            // eventuelle Blanks aus Spiegeleintrag-Liste
            myDB.data[i].spiegeleintrag = strip_blanks (myDB.data[i].spiegeleintrag);
         }
      
         fill_dropdowns();
         
         // Daten-Konsistenz prüfen
         if (debug)
            check_data ();

         // alle 999999-Datensätze aus indexorder.avv_schluessel entfernen
         var anz = myDB.indexorder.avv_schluessel.length;
         while (myDB.data[myDB.indexorder.avv_schluessel[--anz]].avv_schluessel == noAVV6) {
            myDB.indexorder.avv_schluessel.pop();
         }

         // Aufrufparameter AVV_KEY oder AVV_SCHLUESSEL vorhanden?
         
         setActiveFld('avv_schluessel');


         if (parent.avvkey) { 
            var fld = parent.ContentFrame.document.Form1.avv_schluessel;
            fld.value = parent.avvkey;
            setActiveFld('avv_schluessel');
            // alert ("avv_schluessel = " + fld.value);
            suchen('avv_schluessel',true);            
         }         
         // Aufrufparameter BASELCODE vorhanden?
         else if (parent.baselcode) { 
            var fld = parent.ContentFrame.document.Form1.basel_code;
            fld.value = parent.baselcode;
            setActiveFld('basel_code');
            // alert ("baselcode = " + fld.value);
            suchen('basel_code',true);
         }         
         // Aufrufparameter OECDCODE vorhanden?
         else if (parent.oecdcode) { 
            var fld = parent.ContentFrame.document.Form1.oecd_code;
            fld.value = parent.oecdcode;
            setActiveFld('oecd_code');
            // alert ("oecdcode = " + fld.value);
            suchen('oecd_code',true);
         }
         
         if (debug && anz_all) {         
            show_JSON ();
         }
         
      }      
      
      // Initialisierung von Abfrage aus
      if (by == 'abfrage') {
   
         // aktuellen Datensatz anzeigen
         show_data (akt_index);

         // eventuell vorhandenes Suchergebnis anzeigen
         if (anz_gefunden > 0) {
            show_gefunden ();
         }
      
         // letzten Bildschirm-Inhalt wieder herstellen
         if (AktScreen)
            AktScreen.writescreen();
            
         fill_dropdowns();         
      }
      
      language_init (langspec.code);
      
      parent.ContentFrame.focus();
      
   }  // if (form)
}
   
// ****************************************************************************
// ****************************************************************************